/* 

   This code was ported to the Sega Dreamcast ( all rights reserved )
   using KOS ( http://dcdev.allusion.net/ ) and its addon library KGL.
   
   It was ported by Stephen Bolton ( aka HyperG - hyper_gamer13@hotmail.com ).
   
   I also would like to thank Flecko for helping me get started with OpenGL.
   
*/

//
// This code was originally created by Jeff Molofee '99 (ported to Linux/GLUT by Richard Campbell '99)
//
// If you've found this code useful, please let me know.
//
// Visit me at www.demonews.com/hosted/nehe 
// (email Richard Campbell at ulmont@bellsouth.net)
//
#include <kos.h>
#include <GL\gl.h>			// Header File For The OpenGL32 Library
#include <GL\glu.h>			// Header File For The GLu32 Library

/* rotation angle for the triangle. */
float rtri = 0.0f;

/* rotation angle for the quadrilateral. */
float rquad = 0.0f;

/* The function called when our window is resized (which shouldn't happen, because we're fullscreen) */
GLvoid ReSizeGLScene()
{
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();

  gluPerspective(45.0f,640.0f/480.0f,0.1f,100.0f);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
}

/* The main drawing function. */
void DrawGLScene()
{
  glLoadIdentity();				// Reset The View

  glTranslatef(-1.5f,0.0f,-6.0f);		// Move Left 1.5 Units And Into The Screen 6.0
	
  glRotatef(rtri,0.0f,1.0f,0.0f);		// Rotate The Triangle On The Y axis 
  // draw a triangle (in smooth coloring mode)
  glBegin(GL_TRIANGLES);				// start drawing a polygon
  glColor3f(1.0f,0.0f,0.0f);			// Set The Color To Red
  glVertex3f( 0.0f, 1.0f, 0.0f);		// Top
  glColor3f(0.0f,1.0f,0.0f);			// Set The Color To Green
  glVertex3f( 1.0f,-1.0f, 0.0f);		// Bottom Right
  glColor3f(0.0f,0.0f,1.0f);			// Set The Color To Blue
  glVertex3f(-1.0f,-1.0f, 0.0f);		// Bottom Left	
  glEnd();					// we're done with the polygon (smooth color interpolation)

  glLoadIdentity();				// make sure we're no longer rotated.
  glTranslatef(1.5f,0.0f,-6.0f);		// Move Right 3 Units, and back into the screen 6.0
	
  glRotatef(rquad,1.0f,0.0f,0.0f);		// Rotate The Quad On The X axis 
  // draw a square (quadrilateral)
  glColor3f(0.5f,0.5f,1.0f);			// set color to a blue shade.
  glBegin(GL_QUADS);				// start drawing a polygon (4 sided)
  glVertex3f(-1.0f, 1.0f, 0.0f);		// Top Left
  glVertex3f( 1.0f, 1.0f, 0.0f);		// Top Right
  glVertex3f( 1.0f,-1.0f, 0.0f);		// Bottom Right
  glVertex3f(-1.0f,-1.0f, 0.0f);		// Bottom Left	
  glEnd();					// done with the polygon

  rtri+=0.1f;				        // Increase The Rotation Variable For The Triangle
  rquad-=0.1f;//PC default -- 15.0f		// Decrease The Rotation Variable For The Quad 

}

int main(int argc, char **argv) 
{
	uint8 c;
	cont_cond_t cond;
	
	kos_init_all(THD_ENABLE | IRQ_ENABLE | TA_ENABLE, ROMDISK_NONE);	// set up KOS
        glKosInit();

        glClearColor(0.0f, 0.0f, 0.0f, 0.0f);		// This Will Clear The Background Color To Black
        glShadeModel(GL_SMOOTH);			// Enables Smooth Color Shading
        c = maple_first_controller();                   // Global for First Controller

        glMatrixMode(GL_PROJECTION);
        glLoadIdentity();				// Reset The Projection Matrix

        glMatrixMode(GL_MODELVIEW);
	
	
	while(1) 
								// Infinite loop, the best kind			
	{
		/* Check key status */
		if (cont_get_cond(c, &cond) < 0)               //Check to see if controller is in
			break; 
		if (!(cond.buttons & CONT_START))              //If the start button is pressed, the program then exits
			break;
			
		glKosBeginFrame();					// Tell KOS to start the frame
		ReSizeGLScene();  					// This isn't really a needed function...but you get the idea
		DrawGLScene();						// Draw the scene
		glKosFinishFrame();					// Tell KOS you're done with the frame
	}
	return 0;
}